//+------------------------------------------------------------------+
//|                                                 Binarnic_1.0.mq4 |
//|                                          Copyright © 2021, Drknn |
//|                                                    drknn@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright © 2021, Drknn"
#property link      "drknn@mail.ru"
//#property strict
string		ExpertName="Binarnic_1.0";
extern string   C1="------ Стратегия -----";
extern int			Strategy_Number=1;// номер торговой стратегии
extern bool			DodgeIgnore=true;// игнорировать ли додж
extern string   C2="------ Параметры ордеров ------";
extern double		StartLot=0.1;// Лот стартового ордера
extern int      TakeProfit=0;// Указывать в пунктах
extern int      StopLoss=0;// Указывать в пунктах
extern bool			CloseIachChandle=false;// Иммитация терминала бинарных опционов
extern string   C3="------ Трейлингстоп -----";
extern int      TrailingStop=0; // 
extern int      TrailingStep=2; // 
extern bool     WaitProfit=false; // 
extern string   C4="--------- Прочие ---------";
extern int      Proskalz=10;
extern int      MAGIC=1234567;
// ------------- Вспомогательные переменные ---------------------
string		SMB,Napravlenie="",Signal="";
int				MinLevel,TicketBuy=0,TicketSell=0,SPR,DGS,GLE;
double		MinLot,MaxLot,TickSize,PR,SL,TP,LOT,PNT;
double		PrOpenLine,PrCloseLine,PrSbrosLine,LastPrOpenLine,LastPrSbrosLine;
datetime	TimeLastOrdera=0;
int				myBars;


//------ Имена линий -----";
string		TrandelineName="T";// Имя линии тренда
string		BuyStopLevel="BS";// Имя Бай-Стоп линии
string		SellStopLevel="SS";// Имя Селл-Стоп линии
string		BuyLimitLevel="BL";// Имя Бай-Лимит линии
string		SellLimitLevel="SL";// Имя Селл-Лимит линии
// ================================================================================================+
//             =============         БЛОК ИНИЦИАЛИЗАЦИИ СОВЕТНИКА          =============           |
// ================================================================================================+
int init(){
	SMB=Symbol();
  DGS=MarketInfo(SMB,MODE_DIGITS);
	TickSize=MarketInfo(SMB,MODE_TICKSIZE);
	if(DGS==5 || DGS==3){
		Proskalz=10*Proskalz;
		//MaxSpraed=10*MaxSpraed;
		if(TrailingStop>0){
			TrailingStop=10*TrailingStop;
			TrailingStep=10*TrailingStep;
		}
	}
	return(0);
}
// ================================================================================================+
//             =============         ДЕИНИЦИАЛИЗАЦИЯ СОВЕТНИКА             =============           |
// ================================================================================================+
void OnDeinit(const int reason){
	if(!IsTesting()){
		string s_Deint;
		switch (reason){
			case 0: s_Deint="советник самостоятельно завершил свою работу"; break;
			case 1: s_Deint="советник удалён с графика либо вручную, либо на график был брошен другой эксперт, что привело к удалению данного"; break;
			case 2: s_Deint="советник перекомпилирован"; break;
			case 3: s_Deint="символ или период графика был изменен"; break;
			case 4: s_Deint="график закрыт, либо трейдер сменил шаблон графика"; break;
			case 5: s_Deint="входные параметры были изменены пользователем"; break;
			case 6: s_Deint="активирован другой счет"; break;
			default: s_Deint="причина деинициализации не ясна"; break;
		}
		
		Print("Советник ",ExpertName," на инструменте ",Symbol()," деинициализирован. Причина: ",s_Deint);
	}
	Comment("");
}
// ================================================================================================+
//             =============         СТАРТ РАБОТЫ СОВЕТНИКА            =============               |
// ================================================================================================+
int start(){
	// -------------------- Определяем направление линии тренда --------------------
	PrOpenLine=ObjectGetValueByShift(TrandelineName,0);// старая цна на линии тренда
  LastPrOpenLine=ObjectGetValueByShift(TrandelineName,2);// новая цена на линии тренда
	Napravlenie="";
	if(LastPrOpenLine<PrOpenLine){
		Napravlenie="UP";
	}
	if(LastPrOpenLine>PrOpenLine){
		Napravlenie="DOWN";
	}
	// -------------------- Формируем торговые сигналы --------------------
	Signal="";
	if(Strategy_Number==0){// Открываемся на каждой свече
		if(Napravlenie=="UP"){
			Signal="UP";
		}
		if(Napravlenie=="DOWN"){
			Signal="DOWN";
		}
	}
	if(Strategy_Number==1){// Открываемся только в направлении трендовой свечи
		if(Open[1]<Close[1]){
			Signal="UP";
		}
		if(Open[1]>Close[1]){
			Signal="DOWN";
		}
	}
	if(Strategy_Number==2){// сигнал - 2 вподряд идущие одного цвета
		if(Open[2]<Close[2] && Open[1]<Close[1]){
			Signal="UP";
		}
		if(Open[2]>Close[2] && Open[1]>Close[1]){
			Signal="DOWN";
		}
		if(DodgeIgnore){// если игнорируем наличие доджа
			if(Open[2]==Close[2]){// вторая додж
				if(Open[3]<Close[3] && Open[1]<Close[1]){// сравниваем первую и третью свечи
					Signal="UP";
				}
				if(Open[3]>Close[3] && Open[1]>Close[1]){// сравниваем первую и третью свечи
					Signal="DOWN";
				}
			}
		}
	}
	
	// -------------------- Блок торга --------------------
	
		// --------------- Закрываем ордера - пробита линия тренда
		if((Napravlenie=="UP" && Close[1]<ObjectGetValueByShift(TrandelineName,1)) ||  Napravlenie=="DOWN" || CloseIachChandle){
			if(SchBuy(MAGIC)>0){
				Close_All_Buy(true,MAGIC,Proskalz);
				RefreshRates();
			}
		}
		if((Napravlenie=="DOWN" && Close[1]>ObjectGetValueByShift(TrandelineName,1)) || Napravlenie=="UP"){
			if(SchSell(MAGIC)>0){
				Close_All_Sell(true,MAGIC,Proskalz);
				RefreshRates();
			}
			RefreshRates();
		}
	if(isNewBar()){	
		// ------------- открытие лонговых позиций ---------------------
		/*Конструкция 
			Close[1]>=ObjectGetValueByShift(TrandelineName,1)
			обязывает цену закрытия последней свечи быть НАД линией тренда
		*/
		if(Napravlenie=="UP" && Signal=="UP" && Close[1]>=ObjectGetValueByShift(TrandelineName,1)){
			TimeLastOrdera=(-1);
			if(SchBuy(MAGIC)<=0){
				TicketBuy=(-1);
			}
			else{
				TicketBuy=Real_TicketLastOrdera("BUY",MAGIC);
				TimeLastOrdera=TimeLastOrdera(TicketBuy);
			}
			if(TicketBuy<0 || (TimeLastOrdera>0 && TimeLastOrdera<Time[0])){
				LOT=ProverkaLota(StartLot);
				PR=NormalizeDouble(Ask,DGS);
				if(StopLoss>0){
					SL=PR-StopLoss*Point;
				}
				else{
					SL=0;
				}
				if(TakeProfit>0){
					TP=PR+TakeProfit*Point;
				}
				else{
					TP=0;
				}
				SL=NormalizeDouble(SL,DGS);
				TP=NormalizeDouble(TP,DGS);
				TicketBuy=OrderSend(SMB,OP_BUY,LOT,PR,Proskalz,SL,TP,NULL,MAGIC,0,CLR_NONE);
				if(TicketBuy<0){
					MakeOrderError(GetLastError(),MinLevel,OP_BUY,LOT,PR,SL,TP);
					Print("Ошибка произошла в блоке открытия Бай-ордеров");
				}
			}
		}
		// -------------------- Открытие шортовых позиций ---------------------
		if(Napravlenie=="DOWN" && Signal=="DOWN" && Close[1]<=ObjectGetValueByShift(TrandelineName,1)){
			TimeLastOrdera=(-1);
			if(SchSell(MAGIC)<=0){
				TicketSell=(-1);
			}
			else{
				TicketSell=Real_TicketLastOrdera("SELL",MAGIC);
				TimeLastOrdera=TimeLastOrdera(TicketSell);
			}
			if(TicketSell<0 || (TimeLastOrdera>0 && TimeLastOrdera<Time[0])){
				LOT=ProverkaLota(StartLot);
				PR=NormalizeDouble(Bid,DGS);
				if(StopLoss>0){
					SL=PR+StopLoss*Point;
				}
				else{
					SL=0;
				}
				if(TakeProfit>0){
					TP=PR-TakeProfit*Point;
				}
				else{
					TP=0;
				}
				SL=NormalizeDouble(SL,DGS);
				TP=NormalizeDouble(TP,DGS);
				TicketSell=OrderSend(SMB,OP_SELL,LOT,PR,Proskalz,SL,TP,NULL,MAGIC,0,CLR_NONE);
				if(TicketSell<0){
					MakeOrderError(GetLastError(),MinLevel,OP_SELL,LOT,PR,SL,TP);
					Print("Ошибка произошла в блоке открытия Селл-ордеров");
				}
			}
		}
	}	
		Comment("\n","цена линии на 1 свече = ",ObjectGetValueByShift(TrandelineName,1),"\n","Направление = ",Napravlenie,"\n","Сигнал = ",Signal,"\n","Buy = ",SchBuy(MAGIC),"\n","Sell = ",SchSell(MAGIC));
		//Comment("\n","Buy = ",SchBuy(MAGIC),"\n","Sell = ",SchSell(MAGIC));
		
	return(0);
}
// ================================================================================================+
//             =============         ПОЛЬЗОВАТЕЛЬСКИЕ ПОДПРОГРАММЫ          =============          |
// ================================================================================================+

// ============ ProverkaLota() =====================================================================
// функция принимает нормализует лот ордера
//-----------------------------------------------------
double ProverkaLota(double LotOrdera){
  string SMB=Symbol(),Temp;
  double MinLots=(MarketInfo(SMB,MODE_MINLOT));
  double MaxLots=MarketInfo(SMB,MODE_MAXLOT);
  double CorrectLot=0;
  int    diglots=0;
  if(MinLots==1 || MinLots==0.1 || MinLots==0.01){
		if(MinLots==1){
			diglots=0;
		}
		if(MinLots==0.1){
			diglots=1;
		}
		if(MinLots==0.01){
			diglots=2;
		}
	}
	Temp=DoubleToStr(LotOrdera,diglots);// отбрасываем лишние числа
	CorrectLot=StrToDouble(Temp);
  if(CorrectLot<MinLots){
    CorrectLot=MinLots;
  }
  if(CorrectLot>MaxLots){
    CorrectLot=MaxLots;
  }
  return(CorrectLot);
}
// =================================================================================================

datetime TimeLastOrdera(int Ticket){
	if(!OrderSelect(Ticket,SELECT_BY_TICKET)){
		Print("Ошибка № ",GetLastError()," при выборе ордера № ",Ticket);
		Print("Ошибка при попытке узнать время открытия ордера");
		return(-1);
	}
	else{
		return(OrderOpenTime());
	}
}

//=========== SchBuy()  ===============================
//  Функция возвращает количество Buy-ордеров
//   SchBuy      - счётчик Buy ордеров
//-----------------------------------------------------------
int SchBuy(int MAGIC){
  string SMB=Symbol();
  int SchBuy=0;
  for(int i=OrdersTotal()-1;i>=0;i--) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
		}
    else {
      if(OrderSymbol()!= SMB || OrderMagicNumber()!= MAGIC){continue;}
      if(OrderType()==OP_BUY){ 
        SchBuy++;
      }  
    }
  }
  return(SchBuy);
}                  
//======================================================


//=========== SchSell()  ===============================
//  Функция возвращает количество Sell-ордеров
//  SchSell  - счётчик Sell ордеров
//-----------------------------------------------------------
int SchSell(int MAGIC){
  string SMB=Symbol();
  int SchSell=0;
  for(int i=OrdersTotal()-1;i>=0;i--){
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
		}
    else {
      if(OrderSymbol()!=SMB || OrderMagicNumber()!=MAGIC){continue;} 
      if(OrderType()==OP_SELL){
        SchSell++;
      }
    }
  }
 return(SchSell);     
}                  
//======================================================


//=========== SchBuyStop(int MAGIC)  ===================
//  Функция возвращает количество BuyStop-ордеров
//  SchBuyStop  - счётчик ордеров BuyStop
//-----------------------------------------------
int SchBuyStop(int MAGIC){
  int SchBuyStop=0; 
  string SMB=Symbol();
  int i;
  for (i=OrdersTotal()-1;i>=0;i--){
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
		}
    else {
      if(OrderSymbol()!=SMB || OrderMagicNumber()!=MAGIC){ continue;}
      if(OrderType()==OP_BUYSTOP){
        SchBuyStop++;
      }
    }
  }
  return(SchBuyStop);    
}                  
//======================================================

//=========== SchSellStop(int MAGIC)  ==================
//  Функция возвращает количество SellStop-ордеров
//  SchSellStop - счётчик ордеров SellStop
//------------------------------------------------
int SchSellStop(int MAGIC){
  int SchSellStop=0;
  string SMB=Symbol();
  int i;
  for(i=OrdersTotal()-1;i>=0;i--){
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
		}
    else {
      if(OrderSymbol()!=SMB || OrderMagicNumber()!=MAGIC){ continue;}
      if(OrderType()==OP_SELLSTOP){
        SchSellStop++;
      }
    }
  }
 return(SchSellStop);
}                  
//======================================================

//=========== SchBuyLimit(int MAGIC)  ==================
//  Функция возвращает количество BuyLimit-ордеров
//  SchBuyLimit - счётчик ордеров BuyLimit
//------------------------------------------------
int SchBuyLimit(int MAGIC){
  int SchBuyLimit=0;
  string SMB=Symbol();
  int i;
  for(i=OrdersTotal()-1;i>=0;i--){
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
		}
    else {
      if(OrderSymbol()!=SMB || OrderMagicNumber()!=MAGIC){continue;}
      if(OrderType()==OP_BUYLIMIT){
        SchBuyLimit++;
      }
    }
  }
  return(SchBuyLimit);  
}                  
//======================================================

//=========== SchSellLimit(int MAGIC)  =================
//  Функция возвращает количество SellLimit-ордеров
//  SchSellLimit  счётчик ордеров SellLimit
//-------------------------------------------------
int SchSellLimit(int MAGIC){
  string SMB=Symbol();
  int SchSellLimit=0;
  int i;
  for(i=OrdersTotal()-1;i>=0;i--){
    if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
		}
    else {
      if(OrderSymbol()!=SMB || OrderMagicNumber()!=MAGIC){ continue;}
      if(OrderType()==OP_SELLLIMIT){
        SchSellLimit++;
      }
    }
  }
  return(SchSellLimit);
}                  

//======================================================

// =================== Close_All_Buy() =======================
// функция закрывает все рыночные и отложенные ордера
// ===========================================================
void Close_All_Buy(bool Delete_Otlozh,int MAGIC, int Prosk){
	string	SMB=Symbol(),NameFunction="Close_All_Buy()";
	int			Ticket=0;
	double	PriseAsk=0,PriseBid=0;
	double	Lot=0,MinTiskSize,PNT;
	int   	Digits,Proskalz;
	while(SchBuy(MAGIC)+SchBuyStop(MAGIC)+SchBuyLimit(MAGIC)>0){	
		for (int i=OrdersTotal()-1;i>=0;i--){
			if (!OrderSelect(i,SELECT_BY_POS, MODE_TRADES)){
				Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
				Print("Ошибка произошла в функции ",NameFunction);
			}
			else {
				if(OrderSymbol()!=SMB || OrderMagicNumber()!=MAGIC){ continue;}
				RefreshRates();
				Digits=MarketInfo(SMB,MODE_DIGITS);
				MinTiskSize=MarketInfo(SMB,MODE_TICKSIZE);// минимальный шаг тика
				PNT=MarketInfo(SMB,MODE_POINT);
				Proskalz=NormalizeDouble(Prosk*MinTiskSize/PNT,0);
				PriseAsk=MarketInfo(SMB,MODE_ASK);
				PriseAsk=NormalizeDouble(PriseAsk,Digits); 
				PriseBid=MarketInfo(SMB,MODE_BID);
				PriseBid=NormalizeDouble(PriseBid,Digits); 
				Ticket=OrderTicket();
				Lot=OrderLots();
				if(OrderType()==OP_BUY){
					if(!OrderClose(Ticket,Lot,PriseBid,Proskalz,CLR_NONE)){
						OrderCloseError(GetLastError(),"BUY",Ticket,Lot,PriseBid,Proskalz);
					}
				}  
				if(Delete_Otlozh && (OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP)){
					if(!OrderDelete(Ticket,CLR_NONE)){
						Print("Ошибка ", GetLastError(), " при удалении отложенного ордера номер ",Ticket," по паре ",SMB);
						Print("Ошибка произошла в функции ",NameFunction);
					}
				}  
			}
		}
	}
}

// =================== Close_All_Sell() =======================
// функция закрывает все рыночные и отложенные ордера
// ===========================================================
void Close_All_Sell(bool Delete_Otlozh,int MAGIC, int Prosk){
	string	SMB=Symbol(),NameFunction="Close_All_Sell()";
	int			Ticket=0;
	double	PriseAsk=0,PriseBid=0;
	double	Lot=0,MinTiskSize,PNT;
	int   	Digits,Proskalz;
	while(SchSell(MAGIC)+SchSellStop(MAGIC)+SchSellLimit(MAGIC)>0){
		for (int i=OrdersTotal()-1;i>=0;i--){
			if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
				Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
				Print("Ошибка произошла в функции ",NameFunction);
			}
			else {
				if(OrderSymbol()!=SMB || OrderMagicNumber()!=MAGIC){ continue;}
				RefreshRates();
				Digits=MarketInfo(SMB,MODE_DIGITS);
				MinTiskSize=MarketInfo(SMB,MODE_TICKSIZE);// минимальный шаг тика
				PNT=MarketInfo(SMB,MODE_POINT);
				Proskalz=NormalizeDouble(Prosk*MinTiskSize/PNT,0);
				PriseAsk=MarketInfo(SMB,MODE_ASK);
				PriseAsk=NormalizeDouble(PriseAsk,Digits); 
				PriseBid=MarketInfo(SMB,MODE_BID);
				PriseBid=NormalizeDouble(PriseBid,Digits); 
				Ticket=OrderTicket();
				Lot=OrderLots();
				if(OrderType()==OP_SELL){
					if(!OrderClose(Ticket,Lot,PriseAsk,Proskalz,CLR_NONE)){
						OrderCloseError(GetLastError(),"SELL",Ticket,Lot,PriseAsk,Proskalz);
					}
				}  
				if(Delete_Otlozh && (OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP)){
					if(!OrderDelete(OrderTicket(),CLR_NONE)){
						Print("Ошибка ", GetLastError(), " при удалении отложенного ордера номер ",Ticket," по паре ",SMB);
						Print("Ошибка произошла в функции ",NameFunction);
					}
				}  
			}
		}
	}
}

// =================== Real_TicketLastOrdera() =====================================================
// Функция возвращает тикет последнего открытого ордера
// -----------------------------------------
int Real_TicketLastOrdera(string Type,int MAGIC){
	string NameFunction="Real_TicketLastOrdera()";
	int Ticket=-1;
	string	SMB=Symbol();
	datetime	OrderTime=0;
	// ----------------- Обработка ошибок ------------------------
	if(Type!="BUY" && Type!="SELL" && Type!="BUYSTOP" && Type!="SELLSTOP" && Type!="BUYLIMIT" && Type!="SELLLIMIT"){
		Print("Некорректное значение переменной Type = ",Type);
		Print("Basic. Ошибка возникла в функции ",NameFunction);
		return(-1);
	}
	for(int i=OrdersTotal()-1;i>=0;i--){
    if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
			Print("Basic. Ошибка возникла в функции ",NameFunction);
			return(-1);
		}
    else{
      if(OrderSymbol()!= SMB || OrderMagicNumber()!= MAGIC){continue;}
      if(Type=="BUY"){
				if(OrderType()!=OP_BUY){
					continue;
				}
				else{
					if(OrderTime<OrderOpenTime()){
						OrderTime=OrderOpenTime();
						Ticket=OrderTicket();
					}
				}
			}
			if(Type=="SELL"){
				if(OrderType()!=OP_SELL){
					continue;
				}
				else{
					if(OrderTime<OrderOpenTime()){
						OrderTime=OrderOpenTime();
						Ticket=OrderTicket();
					}
				}
			}
			if(Type=="BUYSTOP"){
				if(OrderType()!=OP_BUYSTOP){
					continue;
				}
				else{
					if(OrderTime<OrderOpenTime()){
						OrderTime=OrderOpenTime();
						Ticket=OrderTicket();
					}
				}
			}
			if(Type=="SELLSTOP"){
				if(OrderType()!=OP_SELLSTOP){
					continue;
				}
				else{
					if(OrderTime<OrderOpenTime()){
						OrderTime=OrderOpenTime();
						Ticket=OrderTicket();
					}
				}
			}
			if(Type=="BUYLIMIT"){
				if(OrderType()!=OP_BUYLIMIT){
					continue;
				}
				else{
					if(OrderTime<OrderOpenTime()){
						OrderTime=OrderOpenTime();
						Ticket=OrderTicket();
					}
				}
			}
			if(Type=="SELLLIMIT"){
				if(OrderType()!=OP_SELLLIMIT){
					continue;
				}
				else{
					if(OrderTime<OrderOpenTime()){
						OrderTime=OrderOpenTime();
						Ticket=OrderTicket();
					}
				}
			}
    }
  }
	return(Ticket);
}

// -------------------------------------------------------------------
void MakeOrderError(int GLE,int MinLevel,int CMD,double Lot,double PR,double SL,double TP){
  string ED=ErrorDescription(GLE);
  string	TipOrdera="";
	/*
		OP_BUY        0 Покупка 
		OP_SELL       1 Продажа 
		OP_BUYLIMIT   2 Отложенный ордер BUY LIMIT 
		OP_SELLLIMIT  3 Отложенный ордер SELL LIMIT 
		OP_BUYSTOP    4 Отложенный ордер BUY STOP 
		OP_SELLSTOP   5 Отложенный ордер SELL STOP 
	*/
	switch(CMD){
		case 0:	TipOrdera="Buy";	break;
		case 1:	TipOrdera="Sell";	break;
		case 2:	TipOrdera="BuyLimit";	break;
		case 3:	TipOrdera="SellLimit";	break;
		case 4:	TipOrdera="BuyStop";	break;
		case 5:	TipOrdera="SellStop";	break;
		default:
      TipOrdera="Тип ордера определить не удалось. Переменная CMD = "+CMD;	break;
  }
	Print ("LOT = ",Lot,"   PR = ",DoubleToStr(PR,Digits),"   SL = ",DoubleToStr(SL,Digits),"   TP = ",DoubleToStr(TP,Digits)," Минимальное расстояние для установки стопприказов = ",MinLevel);
  Print ("Описание ошибки: ",ED);
  if(CMD<6 && CMD>(-1)){
		Print("! Ошибка № ",GLE," при установке ",TipOrdera,"-ордера");
	}
	else{
		Print("! Ошибка № ",GLE," при установке ордера. ",TipOrdera);
	}
}
//========= Словестное описание ошибок ===============================
// Функция ErrorDescription() возвращает не код ошибки а её словестное описание
//-----------------------------------------------------------
string ErrorDescription(int error_code){
	string error_string;
  switch(error_code){
		//---- codes returned from trade server
		 case 0:      error_string=" Нет ошибки"; break;
		 case 1:      error_string=" Нет ошибки, но результат неизвестен"; break;
		 case 2:      error_string=" Общая ошибка"; break;
		 case 3:      error_string=" Неправильные параметры"; break;
		 case 4:      error_string=" Торговый сервер занят"; break;
		 case 5:      error_string=" Старая версия клиентского терминала"; break;
		 case 6:      error_string=" Нет связи с торговым сервером"; break;
		 case 7:      error_string=" Недостаточно прав"; break;
		 case 8:      error_string=" Слишком частые запросы"; break;
		 case 9:      error_string=" Недопустимая операция нарушающая функционирование сервера"; break;
		 case 64:     error_string=" Счет заблокирован"; break;
		 case 65:     error_string=" Неправильный номер счета"; break;
		 case 128:    error_string=" Истек срок ожидания совершения сделки"; break;
		 case 129:    error_string=" Неправильная цена"; break;
		 case 130:    error_string=" Неправильные стопы"; break;
		 case 131:    error_string=" Неправильный объем"; break;
		 case 132:    error_string=" Рынок закрыт"; break;
		 case 133:    error_string=" Торговля запрещена"; break;
		 case 134:    error_string=" Недостаточно денег для совершения операции"; break;
		 case 135:    error_string=" Цена изменилась"; break;
		 case 136:    error_string=" Нет цен"; break;
		 case 137:    error_string=" Брокер занят"; break;
		 case 138:    error_string=" Новые цены"; break;
		 case 139:    error_string=" Ордер заблокирован и уже обрабатывается"; break;
		 case 140:    error_string=" Разрешена только покупка"; break;
		 case 141:    error_string=" Слишком много запросов"; break;
		 case 145:    error_string=" Модификация запрещена, так как ордер слишком близок к рынку"; break;
		 case 146:    error_string=" Подсистема торговли занята"; break;
		 case 147:    error_string=" Использование даты истечения ордера запрещено брокером"; break;
		 case 148:    error_string=" Количество открытых и отложенных ордеров достигло предела, установленного брокером"; break;
		 case 4000:   error_string=" Нет ошибки"; break;
		 case 4001:   error_string=" Неправильный указатель функции"; break;
		 case 4002:   error_string=" Индекс массива - вне диапазона"; break;
		 case 4003:   error_string=" Нет памяти для стека функций"; break;
		 case 4004:   error_string=" Переполнение стека после рекурсивного вызова"; break;
		 case 4005:   error_string=" На стеке нет памяти для передачи параметров"; break;
		 case 4006:   error_string=" Нет памяти для строкового параметра"; break;
		 case 4007:   error_string=" Нет памяти для временной строки"; break;
		 case 4008:   error_string=" Неинициализированная строка"; break;
		 case 4009:   error_string=" Неинициализированная строка в массиве"; break;
		 case 4010:   error_string=" Нет памяти для строкового массива"; break;
		 case 4011:   error_string=" Слишком длинная строка"; break;
		 case 4012:   error_string=" Остаток от деления на ноль"; break;
		 case 4013:   error_string=" Деление на ноль"; break;
		 case 4014:   error_string=" Неизвестная команда"; break;
		 case 4015:   error_string=" Неправильный переход"; break;
		 case 4016:   error_string=" Неинициализированный массив"; break;
		 case 4017:   error_string=" Вызовы DLL не разрешены"; break;
		 case 4018:   error_string=" Невозможно загрузить библиотеку"; break;
		 case 4019:   error_string=" Невозможно вызвать функцию"; break;
		 case 4020:   error_string=" Вызовы внешних библиотечных функций не разрешены"; break;
		 case 4021:   error_string=" Недостаточно памяти для строки, возвращаемой из функции"; break;
		 case 4022:   error_string=" Система занята"; break;
		 case 4050:   error_string=" Неправильное количество параметров функции"; break;
		 case 4051:   error_string=" Недопустимое значение параметра функции"; break;
		 case 4052:   error_string=" Внутренняя ошибка строковой функции"; break;
		 case 4053:   error_string=" Ошибка массива"; break;
		 case 4054:   error_string=" Неправильное использование массива-таймсерии"; break;
		 case 4055:   error_string=" Ошибка пользовательского индикатора"; break;
		 case 4056:   error_string=" Массивы несовместимы"; break;
		 case 4057:   error_string=" Ошибка обработки глобальныех переменных"; break;
		 case 4058:   error_string=" Глобальная переменная не обнаружена"; break;
		 case 4059:   error_string=" Функция не разрешена в тестовом режиме"; break;
		 case 4060:   error_string=" Функция не подтверждена"; break;
		 case 4061:   error_string=" Ошибка отправки почты"; break;
		 case 4062:   error_string=" Ожидается параметр типа string"; break;
		 case 4063:   error_string=" Ожидается параметр типа integer"; break;
		 case 4064:   error_string=" Ожидается параметр типа double"; break;
		 case 4065:   error_string=" В качестве параметра ожидается массив"; break;
		 case 4066:   error_string=" Запрошенные исторические данные в состоянии обновления"; break;
		 case 4067:   error_string=" Ошибка при выполнении торговой операции"; break;
		 case 4099:   error_string=" В процессе чтения достигнут конец файла"; break;
		 case 4100:   error_string=" Ошибка при работе с файлом"; break;
		 case 4101:   error_string=" Неправильное имя файла"; break;
		 case 4102:   error_string=" Слишком много открытых файлов"; break;
		 case 4103:   error_string=" Невозможно открыть файл"; break;
		 case 4104:   error_string=" Несовместимый режим доступа к файлу"; break;
		 case 4105:   error_string=" Ни один ордер не выбран"; break;
		 case 4106:   error_string=" Неизвестный символ"; break;
		 case 4107:   error_string=" Неправильный параметр цены для торговой функции"; break;
		 case 4108:   error_string=" Неверный номер тикета"; break;
		 case 4109:   error_string=" Торговля не разрешена"; break;
		 case 4110:   error_string=" Длинные позиции не разрешены"; break;
		 case 4111:   error_string=" Короткие позиции не разрешены"; break;
		 case 4200:   error_string=" Объект уже существует"; break;
		 case 4201:   error_string=" Запрошено неизвестное свойство объекта"; break;
		 case 4202:   error_string=" Объект не существует"; break;
		 case 4203:   error_string=" Неизвестный тип объекта"; break;
		 case 4204:   error_string=" Нет имени объекта"; break;
		 case 4205:   error_string=" Ошибка координат объекта"; break;
		 case 4206:   error_string=" Не найдено указанное подокно"; break;
		 case 4207:   error_string=" Ошибка при работе с объектом"; break;
  }
  
  return(error_string);
}
// ======================= OrderCloseError() =======================================================
// Функция возвращает описание причины ошибочности закрытия ордера
// Переменная TipOrdera может принимать значения только "BUY" или "SELL"
// ---------------------------------------------------------------
void OrderCloseError(int GLE,string TipOrdera,int Ticket,double Lot,double PriseClose,int Proskalz){
	if(TipOrdera!="BUY" && TipOrdera!="SELL"){
		Print("Разрешено подавать только значение = BUY или SELL");
		Print("Непредвиденная ошибка! На вход функции  OrderCloseError() подано значение ",TipOrdera);
		return;
	}
	else{
		string ED=ErrorDescription(GLE);
		Print ("На вход были поданы параметры: Лот = ",DoubleToStr(Lot,2),"  Цена закрытия = ",DoubleToStr(PriseClose,Digits),"  проскальзывание = ",Proskalz);
		Print ("Описание ошибки: ",ED);
		Print(" ! Ошибка № ",GLE," при закрытии рыночного ",TipOrdera,"-ордера № ",Ticket);
	}
}
//+------------------------------------------------------------------+
//| функция isNewBar() - возвращает признак нового бара                                              |
//+------------------------------------------------------------------+
bool isNewBar(){
	bool res=false;
	if(myBars!=Bars){
		res=true;
    myBars=Bars;
  }   
	return(res);
}